/*
Part of KSudoku project
http://ksudoku.sf.net
(c) 2005 Francesco Rossi <redsh@email.it>
(c) 2007 Johannes Bergmeier <Johannes.Bergmeier@gmx.net>
	 Mick Kappenburg <ksudoku@kappenburg.net>
	 Francesco Rossi <redsh@email.it>

This is free software released under GNU GENERAL PUBLIC LICENSE (GPLv2)
See COPYING file in project root directory for more information.

See the credits for this file in AUTHORS file in project root directory
*/
//
// C++ Interface: PuzzleFactory
//
// Description: 
//
//
// Author:  <>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
#ifndef KSUDOKUPUZZLEFACTORY_H
#define KSUDOKUPUZZLEFACTORY_H

#include "puzzle.h"
//#include "ksudokugame.h"
#include "ksudoku_types.h"


namespace ksudoku {


/**
	Generate Puzzles
	Caller will own (and delete) generated puzzle
*/
class PuzzleFactory{
public:
	PuzzleFactory();
	~PuzzleFactory();

	///create a puzzle
	///@warning caller is responsable for deletion
	Puzzle* create_instance(GameType type, int order, int difficulty, int symmetry, bool dub = false, SKSolver* s = NULL);
};

}

#endif
